using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Xml;

namespace nl.in2tech.ConsoleApp
{

   

    class Program
    {
        static int i = 10;


        static void Main()
        {
            using (FileStream reader = File.OpenRead(@"c:\users\karij\documents\TestFile.xml"))
            {
                TestReader(reader);
            }
        }


        static void TestReader(System.IO.Stream stream)
        {
            XmlReaderSettings settings = new XmlReaderSettings();
            //settings.Async = true;

            using (XmlReader reader = XmlReader.Create(stream, settings))
            {
                while ( reader.Read())
                {
                    switch (reader.NodeType)
                    {
                        case XmlNodeType.Element:
                            Console.WriteLine("Start Element {0}", reader.Name);
                            break;
                        case XmlNodeType.Text:
                            Console.WriteLine("Text Node: {0}",
                                 reader.Value);
                            break;
                        case XmlNodeType.EndElement:
                            Console.WriteLine("End Element {0}", reader.Name);
                            break;
                        default:
                            Console.WriteLine("Other node {0} with value {1}",
                                reader.NodeType, reader.Value);
                            break;
                    }
                }
            }
        }


        static void fMain()
        {

            // write to file
            //byte[] bytes= new byte[100];
            //Random r = new Random();
            //for (int i = 0; i < 100; i++)
            //{
            //    bytes[i] = (byte) r.Next();
            //}
            //
            //using (FileStream fs = new FileStream(@"c:\users\karij\documents\File.bin", FileMode.Create))
            //{
            //    fs.Write(bytes, 0, 100);
            //    fs.Close();
            //}

            //-----------------------------------------
            // write to a text file

            //using (StreamWriter writer = File.CreateText(@"c:\users\karij\documents\TestFile.txt"))
            //{
            //    writer.WriteLine("First line of example");
            //    writer.WriteLine("and second line");
            //}

            //using (StreamWriter writer = File.AppendText(@"c:\users\karij\documents\TestFile.txt"))
            //{
            //    writer.WriteLine("2 First line of example");
            //    writer.WriteLine("2 and second line");
            //}

            // read a textfile into an array of strings
            //string[] lines = File.ReadAllLines(@"c:\users\karij\documents\TestFile.txt");

            //List<Data> dataList = new List<Data>();
            //dataList.Add(new Data("Jan", 12));
            //dataList.Add(new Data("Piet", 99));
            //dataList.Add(new Data("Klaas", 21));
            //dataList.Add(new Data("Joep", 55));
            //dataList.Add(new Data("Eva", 44));
            //dataList.Add(new Data("Ellen", 23));

            //using (StreamWriter writer = File.CreateText(@"c:\users\karij\documents\TestFile.csv"))
            //{
            //    writer.WriteLine(Data.HeaderRow());
            //    foreach (var data in dataList)
            //    {
            //        writer.WriteLine(data);
            //    }
            //}

            //string[] dataLines = File.ReadAllLines(@"c:\users\karij\documents\TestFile.csv");

            //List<Data> dataList2 = new List<Data>();
            //for (int index = 1; index < dataLines.Length; index++)
            //{
            //    string current = dataLines[index];
            //    Data d = Data.Parse(current);
            //    dataList2.Add(d);
            //}

            //foreach (var data in dataList2)
            //{
            //    if (data.Age > 22)
            //    {
            //        Console.WriteLine(data);
            //    }
            //}
            //Console.WriteLine("---------------");
            //foreach (var data in dataList2
            //    .Where(d => d.Age > 21)
            //    .OrderBy(d => d.Age )
            //    .ThenBy(d => d.Name)
            //)
            //{
            //    Console.WriteLine(data);
            //}

            Console.ReadLine();
        }


        class Data
        {
            public string Name;
            public int Age;

            public Data(string name, int age)
            {
                Name = name;
                Age = age;
            }

            public static string HeaderRow()
            {
                return "Name,Age";
            }

            public static Data Parse(string current)
            {
                string[] parts = current.Split(',');
                string name = parts[0];
                int age = int.Parse(parts[1]);

                return new Data(name, age);
            }
            public override string ToString()
            {
                //return Name + "," + Age.ToString();
                //return String.Format("{0},{1}", Name, Age);
                return $"{Name},{Age}";
            }
        }



        static void zMain()
        {
            int abc;

            // value samples
            int.TryParse("123", out abc);

            ValueFunc(abc);

            ReferenceFunc(ref abc);

            OutFunc(out abc);


            // reference samples
            ReferenceDemo rd = new ReferenceDemo();
            rd.val = 123;
            rd.s = "orginal";
            ValueFunc(rd);

            ReferenceFunc(ref rd);
        }


        static void ValueFunc(ReferenceDemo rd)
        {
            //i = 456;
            // rd = new ReferenceDemo();
            rd.val = 456;
        }

        static void ReferenceFunc(ref ReferenceDemo rd)
        {
            rd = new ReferenceDemo();
            rd.val = 123;
            //i = 456;
        }

        //static void OutFunc(out iReferenceDemont i)
        //{

        //}

        static void ValueFunc(int i)
        {
            i = 456;
        }

        static void ReferenceFunc(ref int i)
        {
            i = 456;
        }

        static void OutFunc(out int i)
        {
            i = 0;
            if (true) return;
            i = 1234;
        }


        static void yMain()
        {
            D d1 = new D();
            D d2 = new D(123);
            D d3 = new D(123, 456);

            int f = fac(5);

            string s = "abc";
            int iii;
            bool b = int.TryParse(s, out iii);

            try
            {
                int xx = int.Parse(s);


                int ii = x(123, 0);
            }
            catch (DivideByZeroException ex)
            {
                string m = ex.Message;
                throw;
            }
            catch (MyException mx)
            {
                string m = mx.Message;
            }
            catch (Exception sx)
            {
                string m = sx.Message;
            }


        }

        static int fac(int i)
        {
            if (i == 1) return i;

            return i * fac(i - 1);
        }

        static int x(int i1, int i2)
        {
            //x(0, 0);


            int i3;

            i3 = i1 + i1;


            //if (i2 == 0) throw new MyException("Stupid ... don't devide by zero!");
            try
            {
                i3 = i1 / i2;
            }
            catch (DivideByZeroException de)
            {
                throw new MyException(de.Message, de);
            }
            finally
            {
                Int16 z = 0;
            }

            int i4 = i3;
            return i4;
        }

        static void xMain(string[] args)
        {
            Console.WriteLine("Hallo Wereld!");

            Console.WriteLine(i);

            i += 10;

            Console.WriteLine(i);

            Console.ReadLine();

            abc();
            namespace1.Program.abc();
        }

        public static void abc()
        {

        }
    }

    class MyException : Exception
    {
        public MyException(string message) : base(message)
        {

        }
        public MyException(string message, Exception ex) : base(message, ex)
        {

        }
    }


    internal class B
    {
        private int h;

        public B() : this(12) { }

        public B(int h) { this.h = h; }
    }

    internal class D : B
    {
        private int i;

        public D() : this(24) { }

        public D(int i) { this.i = i; }

        public D(int i, int h) : base(h) { this.i = i; }
    }

    struct ReferenceDemo
    {
        public int val;
        public string s;
    }

    //class ReferenceDemo
    //{
    //    public int val;
    //    public string s;
    //}


}

namespace namespace1
{
    class Program
    {
        public static void abc()
        {

        }
    }

}