using System.Drawing;

namespace DrawingApp
{
    class MyCircle : MyBase
    {

        public int W;
        public int H;

        public MyCircle(int x, int y, int w, int h) : base(x, y)
        {
            W = w;
            H = h;
        }

        public override void Draw(Graphics canvas)
        {
            canvas.DrawEllipse(Pens.Black, X, Y, W, H);
        }

 

        public override string ToString()
        {
            return $"{X}, {Y}, {W}, {H}";
        }
    }
}